package de.java2html.eclipse.util;

import java.io.Reader;
import java.io.StringReader;

import org.eclipse.jdt.core.IMethod;

/**
 * @author Markus Gebhard
 */
public class ReadableDocumentMethodAdapter implements ReadableDocument {
  private IMethod method;
  private String name;
  
  public ReadableDocumentMethodAdapter(IMethod method) {
    this.method = method;
    this.name = method.getParent().getElementName();
  }

  /**
   * @see de.java2html.eclipse.util.ReadableDocument#getReader()
   */
  public Reader getReader() throws Exception {
    return new StringReader(method.getSource());
  }

  /**
   * @see de.java2html.eclipse.util.ReadableDocument#getName()
   */
  public String getName() {
    return name;
  }

  /**
   * @see de.java2html.eclipse.util.ReadableDocument#setName(java.lang.String)
   */
  public void setName(String name) {
    this.name = name;
  }
}
